﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Steema.TeeChart.Styles;
using Steema.TeeChart.Drawing;
using Steema.TeeChart;

namespace GeneralTest
{
  public class CustomBarSize : Bar
  {
    private ValueList sizeValues;
    private int ISize;

    public CustomBarSize():this((Chart)null) { }

    public CustomBarSize(Chart c) : base(c) 
    { 
      sizeValues=new ValueList(this,"xSize");
    }
    private void InternalCalcBarSize(int valueIndex)
    {
      if(sizeValues[valueIndex]==0)
        IBarSize=ISize;
      else
        IBarSize=GetHorizAxis.CalcSizeValue(sizeValues[valueIndex]);
    }
    protected override bool InternalClicked(int valueIndex, System.Drawing.Point p)
    {
      InternalCalcBarSize(valueIndex);
      return(base.InternalClicked(valueIndex,p));
    }
    public override void DrawValue(int valueIndex)
    {
      if(valueIndex==firstVisible) ISize=IBarSize;

      InternalCalcBarSize(valueIndex);

      // Call default Bar drawing method.
      base.DrawValue(valueIndex);
    }
    public ValueList SizeValues 
    {
      get { return sizeValues; }
      set { SetValueList(sizeValues,value); }
    }
  }

}
